#ifndef morfo_morfofun_hh
#define morfo_morfofun_hh

#include <string>
using std::string;

extern bool Is_K(char c);
extern bool Is_L(char c);
extern bool Is_P(char c);
extern bool Is_V(char c);

/* Returns true if mask matches word. */
extern bool Match(const string &word, const string &mask);

/* Replaces mask from word with pat. */
extern const string Replace(const string &word, const string &mask, const string &pat);

typedef enum { PREESENS, IMPERFEKTI, PERFEKTI, PLUSKVAMPERFEKTI } aikamuoto;
typedef enum { NOMINATIIVI, GENETIIVI, AKKUSATIIVI, ESSIIVI, PARTITIIVI,
               TRANSLATIIVI, INESSIIVI, ELATIIVI, ILLATIIVI, ADESSIIVI,
               ABLATIIVI, ALLATIIVI, ABESSIIVI, KOMITATIIVI, INSTRUKTIIVI,
               MULTIPLIKATIIVI } sijamuoto;
typedef enum { YKS1=0, YKS2=1, YKS3=2, MON1=3, MON2=4, MON3=5, PASSIIVI=6, NEGPASS=7, NEGAKT=8 } persoona;

typedef enum { INDIKATIIVI, KONDITIONAALI, POTENTIAALI, IMPERATIIVI, PARTISIIPPI1, PARTISIIPPI2,
               INFINITIIVI1, INFINITIIVI2, INFINITIIVI3, INFINITIIVI4, INFINITIIVI5,
               POSITIIVI, KOMPARATIIVI, SUPERLATIIVI } tapaluokka;

extern void Trim(string &s);


#include <vector>
#include <cstdio>
using std::vector;

using std::fopen;
using std::FILE;
using std::fclose;
using std::fprintf;

class Struktit_Apu
{
	unsigned state;
	string hdr, mask, s;
	vector<string> tab;
public:
	Struktit_Apu() : state(6) { }
	const unsigned size() const { return tab.size(); }
	const vector<string> &get_tab() const { return tab; }
	inline const string &get_hdr() const { return hdr; }	
	inline const string &get_mask() const { return mask; }
	int Get(FILE *fp);
};

template<class T>
class Struktit
{
	vector<T> struktit;
	const char *type;
public:
	Struktit(const char *fn, const char *t) : type(t)
	{
		FILE *fp = fopen(fn, "rt");
		if(!fp)throw;		
		
		T temp;
		Struktit_Apu Apu;
		for(;;)
		{
			int c = Apu.Get(fp);
			if(c < 0)
			{
				if(temp.mask.size())
				{
					struktit.push_back(temp);
					temp.mask.erase();
				}
				break;
			}
			if(!c)
				temp.set(Apu.get_hdr(), Apu.get_tab());
			else
			{
				if(temp.mask.size())struktit.push_back(temp);
				temp.clear();
				temp.mask = Apu.get_mask();
			}
		}
		fclose(fp);
	}
	const T &find(const string &word) const
	{
		for(unsigned a=0; a<struktit.size(); ++a)
			if(Match(word, struktit[a].mask))
			{
				fprintf(stderr, "[%sdebug]: '%s' sopii thn: '%s'\n", type, word.c_str(), struktit[a].mask.c_str());
				return struktit[a];
			}
		fprintf(stderr, "Onko '%s' varmasti %s?\n", word.c_str(), type);
		return struktit[0]; /* Fail */
	}
};

#endif
